unit UnitFormEntityOrders;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UnitFormEntityBase, Menus, ActnList, ImgList, ComCtrls, ToolWin,
  UnitObjectEntityOrders, UnitObjectBase, DBCtrls, Db, StdCtrls, Mask,
  UnitObjectEntityCustomer;

type
  TFormEntityOrders = class(TFormEntityBase)
    Label1: TLabel;
    DBEdit1: TDBEdit;
    DataSourceOrders: TDataSource;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    DBEdit7: TDBEdit;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    Label9: TLabel;
    DBEdit9: TDBEdit;
    Label10: TLabel;
    DBEdit10: TDBEdit;
    Label11: TLabel;
    DBEdit11: TDBEdit;
    Label12: TLabel;
    DBEdit12: TDBEdit;
    Label13: TLabel;
    DBEdit13: TDBEdit;
    Label14: TLabel;
    DBEdit14: TDBEdit;
    Label15: TLabel;
    DBEdit15: TDBEdit;
    Label16: TLabel;
    DBEdit16: TDBEdit;
    Label17: TLabel;
    DBEdit17: TDBEdit;
    Label18: TLabel;
    DBEdit18: TDBEdit;
    Label19: TLabel;
    DBEdit19: TDBEdit;
    Label20: TLabel;
    DBEdit20: TDBEdit;
    Label21: TLabel;
    DBEdit21: TDBEdit;
    DBText1: TDBText;
    Label22: TLabel;
    DataSourceCustomer: TDataSource;
    procedure DBText1Click(Sender: TObject);
  private
    FCustomerObject: TObjectEntityCustomer;
  protected
    procedure InitializeForm; override;
    procedure FinalizeForm; override;
    function BusinessObjectClass: TObjectBaseClass; override;
  public
    function OrdersObject: TObjectEntityOrders;
  end;

var
  FormEntityOrders: TFormEntityOrders;

implementation

uses UnitFormEntityCustomer;

{$R *.DFM}

{ TFormEntityOrders }

function TFormEntityOrders.BusinessObjectClass: TObjectBaseClass;
begin
  Result := TObjectEntityOrders;
end;

procedure TFormEntityOrders.InitializeForm;
var aCustomerKey: integer;
begin
  inherited;
  DataSourceOrders.DataSet := OrdersObject.QueryOrders;

  aCustomerKey := OrdersObject.QueryOrders.FieldByName('CustNo').AsInteger;
  FCustomerObject
    := (TObjectEntityCustomer.FetchReference(Self, aCustomerKey)
    as TObjectEntityCustomer);
  DataSourceCustomer.DataSet := FCustomerObject.QueryCustomer;

  Self.Caption := 'Order ' + IntToStr(Key);
end;

function TFormEntityOrders.OrdersObject: TObjectEntityOrders;
begin
  Result := (BusinessObject as TObjectEntityOrders);
end;

procedure TFormEntityOrders.DBText1Click(Sender: TObject);
var aCustomerKey: integer;
begin
  inherited;
  aCustomerKey := OrdersObject.QueryOrders.FieldByName('CustNo').AsInteger;
  TFormEntityCustomer.FetchForm(aCustomerKey).ShowForm;
end;

procedure TFormEntityOrders.FinalizeForm;
begin
  FCustomerObject.FreeReference(Self);
  inherited;
end;

end.
