unit UnitObjectEntityEmployee;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UnitObjectEntityBase, Db, DBTables;

type
  TObjectEntityEmployee = class(TObjectEntityBase)
    QueryEmployee: TQuery;
  private
  protected
    procedure InitializeObject; override;
  public
    function UpdatesPending: boolean; override;
    procedure Save; override;
    procedure Cancel; override;
  end;

implementation

{$R *.DFM}

{ TObjectEntityEmployee }

procedure TObjectEntityEmployee.Cancel;
begin
  inherited;
  QueryEmployee.Cancel;
end;

procedure TObjectEntityEmployee.InitializeObject;
begin
  inherited;
  QueryEmployee.ParamByName('EmpNo').AsInteger := Key;
  QueryEmployee.Open;
end;

procedure TObjectEntityEmployee.Save;
begin
  inherited;
  QueryEmployee.Post;
end;

function TObjectEntityEmployee.UpdatesPending: boolean;
begin
  Result := (QueryEmployee.State in [dsInsert, dsEdit]);
end;

end.
