unit UnitObjectResultSetEmployee;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UnitObjectResultSetBase, Db, DBTables;

type
  TObjectResultSetEmployee = class(TObjectResultSetBase)
    QueryEmpNo: TIntegerField;
    QueryLastName: TStringField;
    QueryFirstName: TStringField;
    QueryPhoneExt: TStringField;
    QueryHireDate: TDateTimeField;
    QuerySalary: TFloatField;
  private
    { Private declarations }
  protected
    function GetSqlSelectClause: string; override;
    function GetSqlFromClause: string; override;
    function GetSelectedRecordKey: integer; override;
  public
  end;

implementation

{$R *.DFM}

{ TObjectResultSetEmployee }

function TObjectResultSetEmployee.GetSelectedRecordKey: integer;
begin
  Result := Query.FieldByName('EmpNo').AsInteger;
end;

function TObjectResultSetEmployee.GetSqlFromClause: string;
begin
  Result := 'employee.db';
end;

function TObjectResultSetEmployee.GetSqlSelectClause: string;
begin
  Result := '*';
end;

end.
