unit DMQueryTableProducer;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBWeb, DB, Asptlb;

type
  TDMQueryTableProducer = class(TQueryTableProducer)
  private
    FRequest: IRequest;
  public
    constructor Create(AOwner: TComponent); override;
    function Content: String; override;
  published
    property Request: IRequest read FRequest write FRequest;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('DrBob42', [TDMQueryTableProducer]);
end;

{ TDMQueryTableProducer }

constructor TDMQueryTableProducer.Create(AOwner: TComponent);
begin
  inherited;
  FRequest := nil;
end;

function TDMQueryTableProducer.Content: String;
var
  i: Integer;
begin
  Result := '';
  if Query <> nil then
  begin
    Query.Close;
    if Assigned(FRequest) then
      for i:=0 to Pred(Query.ParamCount) do
        Query.Params[i].Value := FRequest.Item[Query.Params[i].Name];
    Query.Open;
    if DoCreateContent then
      Result := Header.Text + HTMLTable(Query, Self, MaxRows) + Footer.Text
  end
end {Content};

end.
