unit UnitObjectEntityCustomer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UnitObjectEntityBase, Db, DBTables;

type
  TObjectEntityCustomer = class(TObjectEntityBase)
    QueryCustomer: TQuery;
  private
    { Private declarations }
  protected
    procedure InitializeObject; override;
  public
    function UpdatesPending: boolean; override;
    procedure Save; override;
    procedure Cancel; override;
  end;

implementation

{$R *.DFM}

{ TObjectEntityCustomer }

function TObjectEntityCustomer.UpdatesPending: boolean;
begin
  Result := (QueryCustomer.State in [dsInsert, dsEdit]);
end;

procedure TObjectEntityCustomer.InitializeObject;
begin
  inherited;
  QueryCustomer.ParamByName('CustNo').AsInteger := Key;
  QueryCustomer.Open;
end;

procedure TObjectEntityCustomer.Cancel;
begin
  inherited;
  QueryCustomer.Cancel;
end;

procedure TObjectEntityCustomer.Save;
begin
  inherited;
  QueryCustomer.Post;
end;

end.
