unit UnitObjectResultSetCustomer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UnitObjectResultSetBase, Db, DBTables;

type
  TObjectResultSetCustomer = class(TObjectResultSetBase)
    QueryCompany: TStringField;
    QueryAddr1: TStringField;
    QueryAddr2: TStringField;
    QueryCity: TStringField;
    QueryState: TStringField;
    QueryZip: TStringField;
    QueryCountry: TStringField;
    QueryPhone: TStringField;
    QueryFAX: TStringField;
    QueryTaxRate: TFloatField;
    QueryContact: TStringField;
    QueryLastInvoiceDate: TDateTimeField;
    QueryCustNo: TFloatField;
  private
    { Private declarations }
  protected
    function GetSqlSelectClause: string; override;
    function GetSqlFromClause: string; override;
    function GetSelectedRecordKey: integer; override;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

{ TObjectResultSetCustomer }

function TObjectResultSetCustomer.GetSelectedRecordKey: integer;
begin
  Result := Query.FieldByName('CustNo').AsInteger;
end;

function TObjectResultSetCustomer.GetSqlFromClause: string;
begin
  Result := 'customer.db';
end;

function TObjectResultSetCustomer.GetSqlSelectClause: string;
begin
  Result := '*';
end;

end.
